<?php
// include class 
include_once 'class/Student.php';
// object
$studentObj = new Student();
// post method
$_post = $_POST;
$json = array();	
$studentInfo = array();
// create student record in database
if(!empty($_post['action']) && $_post['action']=="create") {
  $studentObj->setRollNo($_post['roll_no']);
	$studentObj->setName($_post['name']);
	$studentObj->setEmail($_post['email']);
	$studentObj->setAddress($_post['address']);
  $studentObj->setGender($_post['gender']);
  $studentObj->setClass($_post['class_name']);
	$status = $studentObj->create();
	if(!empty($status)){
		$json['msg'] = 'success';
		$json['task_id'] = $status;
	} else {
		$json['msg'] = 'failed';
		$json['task_id'] = '';
	}
	header('Content-Type: application/json');
  echo json_encode($json);  	
}

// get all student records in database
if(!empty($_post['action']) && $_post['action']=="fetch_all_student") {

  if(!empty($_post["search"]["value"])){
       $studentObj->setSearchVal($_post["search"]["value"]);       
  }
  if(!empty($_post["order"])){
    $studentObj->setOrderBy($_post["order"]);
  } 

  if($_post["length"]){
      $studentObj->setStart($_post["start"]);
      $studentObj->setLength($_post["length"]);
  }
  // get total result
  $totalResult = $studentObj->getTotalResult();
  // get student information
  $studentInformation = $studentObj->getList();
  foreach($studentInformation as $key=>$element) {    
      $studentInfo[] = array(
        $element['roll_no'], 
        $element['name'], 
        $element['gender'],
        $element['email'], 
        $element['address'], 
        $element['class_name'],  
        '<a data-studentid="'.$element["id"].'" class="text-white btn btn-info btn-sm view-student"> View </a>  <a data-studentid="'.$element["id"].'" class="text-white btn btn-success btn-sm update-student"> Edit </a>  <a data-studentid="'.$element["id"].'" class="text-white btn btn-danger btn-sm delete-student"> Delete</a>',
      );    
    }
  // draw data  
  $json['studentData'] = array(
      "draw"        =>  intval($_post["draw"]),
      "recordsTotal"    =>  $totalResult,
      "recordsFiltered"   =>  count($studentInformation),  
      "data"          =>  $studentInfo
    );
  header('Content-Type: application/json');
  echo json_encode($json['studentData']); 
}

// get student record in database
if(!empty($_post['action']) && $_post['action']=="fetch_student") {
	$studentObj->setStudentID($_post['student_id']);
	$json['fetchStudent'] = $studentObj->getStudent();
	header('Content-Type: application/json');
	echo json_encode($json['fetchStudent']); 
}

// update student record in database
if(!empty($_post['action']) && $_post['action']=="update") {
	$studentObj->setStudentID($_post['student_id']);
  $studentObj->setRollNo($_post['roll_no']);
	$studentObj->setName($_post['name']);
  $studentObj->setEmail($_post['email']);
  $studentObj->setAddress($_post['address']);
  $studentObj->setGender($_post['gender']);
  $studentObj->setClass($_post['class_name']);
	$status = $studentObj->update();
	if(!empty($status)){
		$json['msg'] = 'success';
	} else {
		$json['msg'] = 'failed';
	}
	header('Content-Type: application/json');	
	echo json_encode($json); 
}

// delete student record from database
if(!empty($_post['action']) && $_post['action']=="delete") {
	$studentObj->setStudentID($_post['student_id']);
	$status = $studentObj->delete();
	if(!empty($status)){
		$json['msg'] = 'success';
	} else {
		$json['msg'] = 'failed';
	}
	header('Content-Type: application/json');	
	echo json_encode($json);	
}
?>