<?php
include("DBConnection.php");
// Student
class Student 
{
    // Properties    
    protected $db;
    private $_studentID;
    private $_rollNo;
    private $_name;
    private $_email;
    private $_address;
    private $_gender;
    private $_className;
    private $_searchVal;
    private $_orderBy;
    private $_start;
    private $_length;

    // Methods
    public function setStudentID($studentID) {
        $this->_studentID = $studentID;
    }
    public function setName($name) {
        $this->_name = $name;
    }
    public function setRollNo($rollNo) {
        $this->_rollNo = $rollNo;
    }
    public function setEmail($email) {
        $this->_email = $email;
    }
    public function setAddress($address) {
        $this->_address = $address;
    }
    public function setGender($gender) {
        $this->_gender = $gender;
    }
    public function setClass($className) {
        $this->_className = $className;
    }
    public function setSearchVal($searchVal) {
        $this->_searchVal = $searchVal;
    }
    public function setOrderBy($orderBy) {
        $this->_orderBy = $orderBy;
    }
    public function setStart($start) {
        $this->_start = $start;
    }
    public function setLength($length) {
        $this->_length = $length;
    }

    
    // __construct
    public function __construct() {
        $this->db = new DBConnection();
        $this->db = $this->db->returnConnection();
    }

    // create student record in database
    public function create() {
		try {
    		$sql = 'INSERT INTO student (roll_no, name, email, address, class_name, gender)  VALUES (:roll_no, :name, :email, :address, :class_name, :gender)';
    		$data = [
			    'roll_no' => $this->_rollNo,
                'name' => $this->_name,
			    'email' => $this->_email,
                'address' => $this->_address,
                'class_name' => $this->_className,
                'gender' => $this->_gender,
			];
	    	$stmt = $this->db->prepare($sql);
	    	$stmt->execute($data);
			$status = $this->db->lastInsertId();
            return $status;

		} catch (Exception $err) {
    		die("Error!: ".$err);
		}

    }

    // update student record in database
    public function update() {
        try {
		    $sql = "UPDATE student SET roll_no=:roll_no, name=:name, email=:email, address=:address, class_name=:class_name, gender=:gender WHERE id=:student_id";
		     $data = [
			    'roll_no' => $this->_rollNo,
                'name' => $this->_name,
                'email' => $this->_email,
                'address' => $this->_address,
                'class_name' => $this->_className,
                'gender' => $this->_gender,
                'student_id' => $this->_studentID,
			];
			$stmt = $this->db->prepare($sql);
			$stmt->execute($data);
			$status = $stmt->rowCount();
            return $status;
		} catch (Exception $err) {
			die("Error!: " . $err);
		}
    }

    // gwt student record from database
    public function getTotalResult() {
        try {
            $sql = "SELECT * FROM student";
            $stmt = $this->db->prepare($sql);
            $stmt->execute();
            $result = $stmt->rowCount();
            return $result;
        } catch (Exception $e) {
            die("Error!: " . $err);
        }
    }
   
    // get all student records from database
    public function getList() {
    	try {
            // keyword serach
            $sqlQuery = '';
            if(!empty($this->_searchVal)){
                $sqlQuery .= 'WHERE (id LIKE "%'.$this->_searchVal.'%" ';
                $sqlQuery .= ' OR roll_no LIKE "%'.$this->_searchVal.'%" ';            
                $sqlQuery .= ' OR name LIKE "%'.$this->_searchVal.'%" ';
                $sqlQuery .= ' OR email LIKE "%'.$this->_searchVal.'%" ';
                $sqlQuery .= ' OR address LIKE "%'.$this->_searchVal.'%") ';
                $sqlQuery .= ' OR class_name LIKE "%'.$this->_searchVal.'%") ';
                $sqlQuery .= ' OR gender LIKE "%'.$this->_searchVal.'%") ';        
            }
            // sorting
            if(!empty($this->_orderBy)){
                $sqlQuery .= 'ORDER BY '.$this->_orderBy['0']['column'].' '.$this->_orderBy['0']['dir'].' ';
            } else {
                $sqlQuery .= 'ORDER BY id DESC ';
            }
            // paging
            if($this->_length != -1){
                $sqlQuery .= 'LIMIT ' . $this->_start . ', ' . $this->_length;
            }

    		$sql = "SELECT id, roll_no, name, email, address, class_name, gender, created_date FROM student ".$sqlQuery;
		    $stmt = $this->db->prepare($sql);
		    $stmt->execute();
		    $result = $stmt->fetchAll(\PDO::FETCH_ASSOC);
            return $result;
		} catch (Exception $err) {
		    die("Error!: " . $err);
		}
    }
    // gwt student record from database
    public function getStudent() {
        try {
            $sql = "SELECT id, roll_no, name, email, address, class_name, gender, created_date FROM student WHERE id=:student_id";
            $stmt = $this->db->prepare($sql);
            $data = [
                'student_id' => $this->_studentID
            ];
            $stmt->execute($data);
            $result = $stmt->fetch(\PDO::FETCH_ASSOC);
            return $result;
        } catch (Exception $e) {
            die("Error!: " . $err);
        }
    }

    // delete student record from database
    public function delete() {
    	try {
	    	$sql = "DELETE FROM student WHERE id=:student_id";
		    $stmt = $this->db->prepare($sql);
		    $data = [
		    	'student_id' => $this->_studentID
			];
	    	$stmt->execute($data);
            $status = $stmt->rowCount();
            return $status;
	    } catch (Exception $err) {
		    die("Error!: " . $err);
		}
    }

}
?>